VirtualBox

source: vbox/trunk/configure@ 19082

Last change on this file since 19082 was 18916, checked in by vboxsync, 16 years ago

configure: Add /usr/local to the QT4 search path for FreeBSD

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 56.1 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2009 Sun Microsystems, Inc.
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License as published by the Free Software Foundation,
12# in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
13# distribution. VirtualBox OSE is distributed in the hope that it will
14# be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, echo, grep, sed to work)
23PATH="/usr/xpg4/bin:/usr/ucb:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26# Wrapper for ancient /usr/bin/which on darwin that always returns 0
27which_wrapper()
28{
29 if [ -z "$have_ancient_which" ]; then
30 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
31 have_ancient_which="yes"
32 else
33 have_ancient_which="no"
34 fi
35 fi
36 if [ "$have_ancient_which" = "yes" ]; then
37 retval=`which $* 2>/dev/null`
38 echo "$retval"
39 test -n "$retval" -a -x "$retval"
40 unset retval
41 else
42 which $* 2> /dev/null
43 fi
44}
45
46
47#
48# Defaults
49#
50OSE=1
51ODIR="`pwd`/"
52ODIR_OVERRIDE=0
53OUT_PATH=""
54OUT_PATH_OVERRIDE=0
55SETUP_WINE=
56TARGET_MACHINE=""
57TARGET_CPU=""
58WITH_XPCOM=1
59WITH_PYTHON=1
60WITH_LIBIDL=1
61WITH_GSOAP=0
62WITH_QT4=1
63WITH_SDL=1
64WITH_SDL_TTF=1
65WITH_X11=1
66WITH_ALSA=1
67WITH_PULSE=1
68WITH_DBUS=1
69WITH_KMODS=1
70WITH_OPENGL=1
71WITH_HARDENING=1
72CC="gcc"
73CC32=""
74CC64=""
75CXX="g++"
76CXX32=""
77CXX64=""
78BCC="bcc"
79YASM="yasm"
80IASL="iasl"
81AS86="as86"
82XSLTPROC="xsltproc"
83GENISOIMAGE="genisoimage"
84MKISOFS="mkisofs"
85BUILD_LIBXML2=
86BUILD_LIBXSLT=
87LIBCRYPTO="-lcrypto"
88LIBPTHREAD="-lpthread"
89LIBCAP="-lcap"
90GSOAP=""
91GSOAP_IMPORT=""
92LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
93INCX11="/usr/local/include"
94LIBXCURSOR="-lXcursor"
95LIBXMU="-lXmu"
96MESA="-lGL"
97INCZ=""
98LIBZ="-lz"
99INCPNG=""
100LIBPNG="-lpng"
101PKGCONFIG="`which_wrapper pkg-config`"
102PYTHONDIR="/usr /usr/local"
103QT4DIR="/usr/lib/qt4 /usr/share/qt4 /usr/lib64/qt4 /usr /usr/local"
104QT4DIR_PKGCONFIG=1
105QT4UIC3DIR="/usr/bin"
106KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
107DEVDIR="`cd \`dirname $0\`; pwd`/tools"
108if [ -d "/lib/modules/`uname -r`/build" ]; then
109 LINUX="/lib/modules/`uname -r`/build"
110else
111 LINUX="/usr/src/linux"
112fi
113KCHMVIEWER="kchmviewer"
114LOG="configure.log"
115CNF="AutoConfig.kmk"
116ENV="env.sh"
117BUILD_TYPE="release"
118# the restricting tool is ar (mri mode).
119INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
120
121if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
122 echo "Error: VBox base path contains invalid characters!"
123 exit 1
124fi
125
126# darwin /bin/sh has a builtin echo that doesn't grok -n. gotta love it.
127if [ "`uname`" = "Darwin" ]; then
128 ECHO_N="/bin/echo -n"
129else
130 ECHO_N="echo -n"
131fi
132
133
134cleanup()
135{
136 rm -f $ODIR.tmp_src.cc $ODIR.tmp_src.c $ODIR.tmp_out $ODIR.test_execute.log
137}
138
139fail()
140{
141 if [ -z "$nofatal" -o "x$1" != "x" ]; then
142 cleanup
143 rm -f $ENV
144 exit 1
145 fi
146}
147
148log()
149{
150 echo "$1"
151 echo "$1" >> $LOG
152}
153
154log_success()
155{
156 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
157 echo "OK."
158 echo "$1" >> $LOG
159 echo >> $LOG
160 echo >> $LOG
161}
162
163log_failure()
164{
165 echo
166 echo " ** $1!"
167 echo "** $1!" >> $LOG
168 echo >> $LOG
169}
170
171cnf_append()
172{
173 printf "%-30s := %s\n" "$1" "$2" >> $CNF
174}
175
176strip_l()
177{
178 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
179}
180
181strip_L()
182{
183 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
184}
185
186strip_I()
187{
188 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
189}
190
191prefix_I()
192{
193 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
194}
195
196check_avail()
197{
198 if [ -z "$1" ]; then
199 log_failure "$2 is empty"
200 fail $3
201 return 1
202 elif which_wrapper $1 > /dev/null; then
203 return 0
204 else
205 log_failure "$1 (variable $2) not found"
206 fail $3
207 return 1
208 fi
209}
210
211
212# Prepare a test
213test_header()
214{
215 echo "***** Checking $1 *****" >> $LOG
216 $ECHO_N "Checking for $1: "
217}
218
219
220# Compile a test
221# $1 compile flags/libs
222# $2 library name
223# $3 package name
224# $4 if this argument is 'nofatal', don't abort
225test_compile()
226{
227 echo "compiling the following source file:" >> $LOG
228 cat $ODIR.tmp_src.cc >> $LOG
229 echo "using the following command line:" >> $LOG
230 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc \"$1\"" >> $LOG
231 $CXX -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc $1 >> $LOG 2>&1
232 if [ $? -ne 0 ]; then
233 if [ -z "$4" ]; then
234 echo
235 echo " $2 not found at $1 or $3 headers not found"
236 echo " Check the file $LOG for detailed error information."
237 fail
238 else
239 echo "not found."
240 echo >> $LOG
241 echo >> $LOG
242 fi
243 return 1
244 fi
245 return 0
246}
247
248
249# Execute a compiled test binary
250test_execute()
251{
252 echo "executing the binary" >> $LOG
253 $ODIR.tmp_out > $ODIR.test_execute.log
254 rc=$?
255 cat $ODIR.test_execute.log | tee -a $LOG
256 if [ $rc -ne 0 ]; then
257 fail $1
258 return 1
259 fi
260 echo >> $LOG
261 echo >> $LOG
262 return 0
263}
264
265
266# Execute a compiled test binary
267test_execute_path()
268{
269 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
270 LD_LIBRARY_PATH=$1 $ODIR.tmp_out > $ODIR.test_execute.log
271 rc=$?
272 cat $ODIR.test_execute.log | tee -a $LOG
273 if [ $rc -ne 0 ]; then
274 fail
275 return 1
276 fi
277 echo >> $LOG
278 echo >> $LOG
279 return 0
280}
281
282
283#
284# Check for OS, MACHINE, CPU
285#
286check_environment()
287{
288 test_header environment
289 OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr [:upper:] [:lower:]`
290 case "$OS" in
291 linux)
292 ;;
293 darwin)
294 ;;
295 freebsd)
296 ;;
297 sunos)
298 OS='solaris'
299 ;;
300 *)
301 log_failure "Cannot determine OS"
302 exit 1
303 ;;
304 esac
305 BUILD_CPU=`uname -m`
306 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
307 case "$BUILD_CPU" in
308 i[3456789]86|x86|i86pc)
309 BUILD_MACHINE='x86'
310 LIB='lib'
311 ;;
312 x86_64|amd64)
313 BUILD_MACHINE='amd64'
314 BUILD_CPU='k8'
315 if [ "$OS" != "solaris" ]; then
316 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
317 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
318 LIB='lib64'
319 else
320 # Solaris doesn't seem to subscribe to fhs, libs are usually in
321 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
322 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
323 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
324 # have to make sure the */bin/amd64 dirs are searched before the */bin
325 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
326 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
327 echo "old PATH: $PATH" >> $LOG
328 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
329 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
330 export PATH
331 echo "new PATH: $PATH" >> $LOG
332 LIB='lib/64'
333 fi
334 ;;
335 *)
336 log_failure "Cannot determine system"
337 exit 1
338 ;;
339 esac
340 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
341 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
342 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
343 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
344
345 echo "export BUILD_PLATFORM=\"$OS\"" >> $ENV
346 echo "export BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
347 echo "export BUILD_TARGET=\"$OS\"" >> $ENV
348 echo "export BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
349 echo "export BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
350 echo "export BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
351}
352
353#
354# Check for gcc with version >= 3.2.
355# We depend on a working gcc, if we fail terminate in every case.
356#
357check_gcc()
358{
359 test_header gcc
360 if check_avail "$CC" CC really; then
361 cc_ver=`$CC -dumpversion` 2>/dev/null
362 if [ $? -ne 0 ]; then
363 log_failure "cannot execute '$CC -dumpversion'"
364 fail really
365 fi
366 if check_avail "$CXX" CXX really; then
367 cxx_ver=`$CXX -dumpversion` 2>/dev/null
368 if [ $? -ne 0 ]; then
369 log_failure "cannot execute '$CXX -dumpversion'"
370 fail really
371 fi
372 cc_maj=`echo $cc_ver|cut -d. -f1`
373 cc_min=`echo $cc_ver|cut -d. -f2`
374 if [ "x$cc_ver" != "x$cxx_ver" ]; then
375 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
376 fail really
377 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "OS" = "darwin" ]; then
378 log_success "found version $cc_ver"
379 # gcc-4.0 is allowed for Darwin only
380 elif [ $cc_maj -lt 3 \
381 -o \( $cc_maj -eq 3 -a $cc_min -lt 2 \) \
382 -o \( $cc_maj -eq 4 -a $cc_min -lt 1 -a "$OS" != "darwin" \) \
383 -o \( $cc_maj -eq 4 -a $cc_min -gt 3 \) \
384 -o $cc_maj -gt 4 ]; then
385 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with 0<x<4"
386 fail really
387 else
388 log_success "found version $cc_ver"
389 fi
390 if [ "$BUILD_MACHINE" = "amd64" ]; then
391 [ -z "$CC32" ] && CC32="$CC -m32"
392 [ -z "$CXX32" ] && CXX32="$CXX -m32"
393 else
394 [ -z "$CC32" ] && CC32="$CC"
395 [ -z "$CXX32" ] && CXX32="$CXX"
396 fi
397 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
398 [ -z "$CC64" ] && CC64="$CC -m64"
399 [ -z "$CXX64" ] && CXX64="$CXX -m64"
400 fi
401 if [ "$CC" != "gcc" ]; then
402 cnf_append "TOOL_GCC3_CC" "$CC"
403 cnf_append "TOOL_GCC3_AS" "$CC"
404 cnf_append "TOOL_GCC3_LD" "$CC"
405 cnf_append "TOOL_GXX3_CC" "$CC"
406 cnf_append "TOOL_GXX3_AS" "$CC"
407 fi
408 if [ "$CXX" != "g++" ]; then
409 cnf_append "TOOL_GCC3_CXX" "$CXX"
410 cnf_append "TOOL_GXX3_CXX" "$CXX"
411 cnf_append "TOOL_GXX3_LD" "$CXX"
412 fi
413 if [ "$CC32" != "gcc -m32" ]; then
414 cnf_append "TOOL_GCC32_CC" "$CC32"
415 cnf_append "TOOL_GCC32_AS" "$CC32"
416 cnf_append "TOOL_GCC32_LD" "$CC32"
417 cnf_append "TOOL_GXX32_CC" "$CC32"
418 cnf_append "TOOL_GXX32_AS" "$CC32"
419 fi
420 if [ "$CXX32" != "g++ -m32" ]; then
421 cnf_append "TOOL_GCC32_CXX" "$CXX32"
422 cnf_append "TOOL_GXX32_CXX" "$CXX32"
423 cnf_append "TOOL_GXX32_LD" "$CXX32"
424 fi
425 # this isn't not necessary, there is not such tool.
426 if [ -n "$CC64" ]; then
427 cnf_append "TOOL_GCC64_CC" "$CC64"
428 cnf_append "TOOL_GCC64_AS" "$CC64"
429 cnf_append "TOOL_GCC64_LD" "$CC64"
430 cnf_append "TOOL_GXX64_CC" "$CC64"
431 cnf_append "TOOL_GXX64_AS" "$CC64"
432 fi
433 if [ -n "$CXX64" ]; then
434 cnf_append "TOOL_GCC64_CXX" "$CXX64"
435 cnf_append "TOOL_GXX64_CXX" "$CXX64"
436 cnf_append "TOOL_GXX64_LD" "$CXX64"
437 fi
438 # Solaris sports a 32-bit gcc/g++.
439 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
440 [ "$CC" = "gcc" ] && CC="gcc -m64"
441 [ "$CXX" = "g++" ] && CXX="g++ -m64"
442 fi
443 fi
444 fi
445}
446
447
448#
449# Check for the bcc compiler, needed for compiling the BIOS
450#
451check_bcc()
452{
453 test_header bcc
454 if check_avail "$BCC" BCC; then
455 bcc_ver=`$BCC -v 2>&1|grep version|sed 's+^bcc: version \(.*\)+\1+'`
456 if [ $? -ne 0 ]; then
457 log_failure "not found"
458 fail
459 else
460 echo "compiling the following source file:" >> $LOG
461 cat > $ODIR.tmp_src.c << EOF
462int foo(a)
463 int a;
464{
465 return 0;
466}
467EOF
468 cat $ODIR.tmp_src.c >> $LOG
469 bcc_path=`which_wrapper $BCC`
470 bcc_dir="`dirname $bcc_path`/"
471 echo "using the following command line:" >> $LOG
472 echo "$BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
473 $BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
474 if [ $? -ne 0 ]; then
475 log_failure "not found"
476 fail
477 else
478 log_success "found version $bcc_ver"
479 cnf_append "VBOX_BCC" "$bcc_path -B $bcc_dir"
480 fi
481 unset bcc_path
482 unset bcc_dir
483 fi
484 fi
485}
486
487
488#
489# Check for the as86 assembler, needed for compiling the BIOS
490#
491check_as86()
492{
493 test_header as86
494 if check_avail "$AS86" AS86; then
495 as86_ver=`$AS86 -v 2>&1|grep version|sed 's+^as86 version: \(.*\)+\1+'`
496 if [ $? -ne 0 ]; then
497 log_failure "not found"
498 fail
499 else
500 log_success "found version $as86_ver"
501 cnf_append "VBOX_AS86" "`which_wrapper $AS86`"
502 fi
503 fi
504}
505
506
507#
508# Check for yasm, needed to compile assembler files
509#
510check_yasm()
511{
512 test_header yasm
513 if check_avail "$YASM" YASM; then
514 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
515 if [ $? -ne 0 ]; then
516 log_failure "not found"
517 fail
518 else
519 yasm_maj=`echo $yasm_ver|cut -d. -f1`
520 yasm_min=`echo $yasm_ver|cut -d. -f2`
521 yasm_rev=`echo $yasm_ver|cut -d. -f3`
522 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
523 if [ $yasm_ver_mul -lt 501 ]; then
524 log_failure "found version $yasm_ver, expected at least 0.5.1"
525 fail
526 else
527 log_success "found version $yasm_ver"
528 fi
529 fi
530 fi
531}
532
533
534#
535# Check for the iasl ACPI compiler, needed to compile vbox.dsl
536#
537check_iasl()
538{
539 test_header iasl
540 if check_avail "$IASL" IASL; then
541 iasl_ver=`$IASL|grep version|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
542 if [ $? -ne 0 ]; then
543 log_failure "not found"
544 fail
545 else
546 log_success "found version $iasl_ver"
547 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
548 fi
549 fi
550}
551
552
553#
554# Check for xsltproc, needed by Main
555#
556check_xsltproc()
557{
558 test_header xslt
559 if check_avail "$XSLTPROC" XSLTPROC; then
560 xsltproc_ver=`$XSLTPROC --version`
561 if [ $? -ne 0 ]; then
562 log_failure "not found"
563 fail
564 else
565 log_success "found"
566 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
567 fi
568 fi
569}
570
571
572#
573# Check for mkisofs, needed to build the CDROM image containing the additions
574#
575check_mkisofs()
576{
577 test_header mkisofs
578 if which_wrapper $GENISOIMAGE > /dev/null; then
579 mkisofs_ver=`$GENISOIMAGE --version`
580 if [ $? -ne 0 ]; then
581 log_failure "not found"
582 fail
583 else
584 log_success "found $mkisofs_ver"
585 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
586 fi
587 elif check_avail "$MKISOFS" MKISOFS; then
588 mkisofs_ver=`$MKISOFS --version`
589 if [ $? -ne 0 ]; then
590 log_failure "not found"
591 fail
592 else
593 log_success "found $mkisofs_ver"
594 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
595 fi
596 fi
597}
598
599
600#
601# Check for libxml2, needed by VBoxSettings
602# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
603#
604check_libxml2()
605{
606 if [ -z "$BUILD_LIBXML2" ]; then
607 test_header libxml2
608 if which_wrapper pkg-config > /dev/null; then
609 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
610 if [ $? -ne 0 ]; then
611 log_failure "not found"
612 fail
613 else
614 FLGXML2=`pkg-config libxml-2.0 --cflags`
615 INCXML2=`strip_I "$FLGXML2"`
616 LIBXML2=`pkg-config libxml-2.0 --libs`
617 cat > $ODIR.tmp_src.cc << EOF
618#include <cstdio>
619#include <libxml/xmlversion.h>
620extern "C" int main(void)
621{
622 printf("found version %s", LIBXML_DOTTED_VERSION);
623#if LIBXML_VERSION >= 20626
624 printf(", OK.\n");
625 return 0;
626#else
627 printf(", expected version 2.6.26 or higher\n");
628 return 1;
629#endif
630}
631EOF
632 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
633 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
634 if test_execute; then
635 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
636 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
637 fi
638 fi
639 fi
640 elif which_wrapper xml2-config; then
641 libxml2_ver=`xml2-config --version`
642 if [ $? -ne 0 ]; then
643 log_failure "not found"
644 fail
645 else
646 log_success "found version $libxml2_ver"
647 FLGXML2=`xml2-config --cflags`
648 INCXML2=`strip_I "$FLGXML2"`
649 LIBXML2=`xml2-config --libs`
650 cat > $ODIR.tmp_src.cc << EOF
651#include <cstdio>
652#include <libxml/xmlversion.h>
653extern "C" int main(void)
654{
655 printf("found version %s", LIBXML_DOTTED_VERSION);
656#if LIBXML_VERSION >= 20626
657 printf(", OK.\n");
658 return 0;
659#else
660 printf(", expected version 2.6.26 or higher\n");
661 return 1;
662#endif
663}
664EOF
665 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
666 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
667 if test_execute; then
668 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
669 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
670 fi
671 fi
672 fi
673 else
674 log_failure "neither pkg-config nor xml2-config found"
675 fail
676 fi
677 fi
678}
679
680
681#
682# Check for libxslt, needed by VBoxSettings. For now we depend on 1.1.15,
683# as Solaris right now has no newer version and it definitely works.
684# 1.1.17 is available on Ubuntu Edgy which fulfils the minimal libxml2
685# requirement (2.6.26).
686#
687check_libxslt()
688{
689 if [ -z "$BUILD_LIBXSLT" ]; then
690 test_header libxslt
691 if which_wrapper pkg-config > /dev/null; then
692 libxslt_ver=`pkg-config libxslt --modversion 2>> $LOG`
693 if [ $? -ne 0 ]; then
694 log_failure "not found"
695 fail
696 else
697 FLGXSLT=`pkg-config libxslt --cflags`
698 INCXSLT=`strip_I "$FLGXSLT"`
699 LIBXSLT=`pkg-config libxslt --libs`
700 cat > $ODIR.tmp_src.cc << EOF
701#include <cstdio>
702#include <libxslt/xsltconfig.h>
703extern "C" int main(void)
704{
705 printf("found version %s", LIBXSLT_DOTTED_VERSION);
706#if LIBXSLT_VERSION >= 10117
707 printf(", OK.\n");
708 return 0;
709#else
710 printf(", expected version 1.1.17 or higher\n");
711 return 1;
712#endif
713}
714EOF
715 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
716 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
717 if test_execute; then
718 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
719 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
720 fi
721 fi
722 fi
723 elif which_wrapper xslt-config; then
724 libxslt_ver=`xslt-config --version`
725 if [ $? -ne 0 ]; then
726 log_failure "not found"
727 fail
728 else
729 log_success "found version $libxslt_ver"
730 FLGXSLT=`xslt-config --cflags`
731 INCXSLT=`strip_I "$FLGXSLT"`
732 LIBXSLT=`xslt-config --libs`
733 cat > $ODIR.tmp_src.cc << EOF
734#include <cstdio>
735#include <libxslt/xsltconfig.h>
736extern "C" int main(void)
737{
738 printf("found version %s", LIBXSLT_DOTTED_VERSION);
739#if LIBXSLT_VERSION >= 10117
740 printf(", OK.\n");
741 return 0;
742#else
743 printf(", expected version 1.1.17 or higher\n");
744 return 1;
745#endif
746}
747EOF
748 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
749 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
750 if test_execute; then
751 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
752 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
753 fi
754 fi
755 fi
756 else
757 log_failure "neither pkg-config nor xslt-config found"
758 fail
759 fi
760 fi
761}
762
763
764#
765# Check for libIDL, needed by xpcom
766#
767check_libidl()
768{
769 test_header libIDL
770
771 if which_wrapper libIDL-config-2 > /dev/null; then
772 libidl_ver=`libIDL-config-2 --version`
773 if [ $? -ne 0 ]; then
774 log_failure "not found"
775 fail
776 else
777 log_success "found version $libidl_ver"
778 cnf_append "VBOX_LIBIDL_CONFIG" \
779 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
780 fi
781 elif check_avail "libIDL-config" libIDL-config; then
782 libidl_ver=`libIDL-config --version`
783 if [ $? -ne 0 ]; then
784 log_failure "not found"
785 fail
786 else
787 log_success "found version $libidl_ver"
788 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
789 fi
790 fi
791}
792
793
794#
795# Check for openssl, needed for RDP
796#
797check_ssl()
798{
799 test_header ssl
800 cat > $ODIR.tmp_src.cc << EOF
801#include <cstdio>
802#include <openssl/opensslv.h>
803extern "C" int main(void)
804{
805 printf("found version %s", OPENSSL_VERSION_TEXT);
806#if OPENSSL_VERSION_NUMBER >= 0x0090700
807 printf(", OK.\n");
808 return 0;
809#else
810 printf(", expected version 0.9.7 or higher\n");
811 return 1;
812#endif
813}
814EOF
815 if test_compile $LIBCRYPTO libcrypto openssl; then
816 if test_execute nofatal; then
817 cnf_append "SDK_VBOX_OPENSSL_INCS" ""
818 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
819 fi
820 fi
821}
822
823
824#
825# Check for pthread, needed by VBoxSVC, frontends, ...
826#
827check_pthread()
828{
829 test_header pthread
830 cat > $ODIR.tmp_src.cc << EOF
831#include <cstdio>
832#include <pthread.h>
833extern "C" int main(void)
834{
835 pthread_mutex_t mutex;
836 if (pthread_mutex_init(&mutex, NULL)) {
837 printf("pthread_mutex_init() failed\n");
838 return 1;
839 }
840 if (pthread_mutex_lock(&mutex)) {
841 printf("pthread_mutex_lock() failed\n");
842 return 1;
843 }
844 if (pthread_mutex_unlock(&mutex)) {
845 printf("pthread_mutex_unlock() failed\n");
846 return 1;
847 }
848 printf("found, OK.\n");
849}
850EOF
851 if test_compile $LIBPTHREAD pthread pthread; then
852 if test_execute; then
853 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
854 fi
855 fi
856}
857
858
859#
860# Check for zlib, needed by VBoxSVC, Runtime, ...
861#
862check_z()
863{
864 test_header zlib
865 cat > $ODIR.tmp_src.cc << EOF
866#include <cstdio>
867#include <zlib.h>
868extern "C" int main(void)
869{
870 printf("found version %s", ZLIB_VERSION);
871#if ZLIB_VERNUM >= 0x1210
872 printf(", OK.\n");
873 return 0;
874#else
875 printf(", expected version 1.2.1 or higher\n");
876 return 1;
877#endif
878}
879EOF
880 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
881 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
882 if test_execute; then
883 cnf_append "SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
884 cnf_append "SDK_VBOX_ZLIB_INCS" "$INCZ"
885 fi
886 fi
887}
888
889
890#
891# Check for libpng, needed by kchmviewer
892#
893check_png()
894{
895 test_header libpng
896 cat > $ODIR.tmp_src.cc << EOF
897#include <cstdio>
898#include <png.h>
899extern "C" int main(void)
900{
901 printf("found version %s", PNG_LIBPNG_VER_STRING);
902#if PNG_LIBPNG_VER >= 10205
903 printf(", OK.\n");
904 return 0;
905#else
906 printf(", expected version 1.2.5 or higher\n");
907 return 1;
908#endif
909}
910EOF
911 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
912# if test_compile "$LIBPNG $I_INCPNG" libpng libpng nofatal; then
913 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
914# if test_execute nofatal; then
915 if test_execute; then
916 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
917 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
918 fi
919 fi
920}
921
922
923#
924# Check for pam, needed by VRDPAuth
925# Version 79 was introduced in 9/2005, do we support older versions?
926# Debian/sarge uses 76
927# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
928#
929check_pam()
930{
931 test_header pam
932 cat > $ODIR.tmp_src.cc << EOF
933#include <cstdio>
934#include <security/pam_appl.h>
935extern "C" int main(void)
936{
937 printf("found version %d", __LIBPAM_VERSION);
938 if (__LIBPAM_VERSION >= 76)
939 {
940 printf(", OK.\n");
941 return 0;
942 }
943 else
944 {
945 printf(", expected version 76 or higher\n");
946 return 1;
947 }
948}
949EOF
950 if test_compile "-lpam" pam pam nofatal; then
951 if test_execute nofatal; then
952 return 0;
953 fi
954 fi
955 test_header linux_pam
956 cat > $ODIR.tmp_src.cc << EOF
957#include <cstdio>
958#include <security/pam_appl.h>
959extern "C" int main(void)
960{
961 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
962 if (__LINUX_PAM__ >= 1)
963 {
964 printf(", OK.\n");
965 return 0;
966 }
967 else
968 {
969 printf(", expected version 1.0 or higher\n");
970 return 1;
971 }
972}
973EOF
974 if test_compile "-lpam" pam pam; then
975 test_execute
976 fi
977}
978
979
980#
981# Check for the SDL library, needed by VBoxSDL and VirtualBox
982# We depend at least on version 1.2.7
983#
984check_sdl()
985{
986 test_header SDL
987 if [ "$OS" = "darwin" ]; then
988 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
989 PATH_SDK_LIBSDL="/System/Library/Frameworks/SDL.framework"
990 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
991 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
992 fi
993 if [ -n "$PATH_SDK_LIBSDL" ]; then
994 foundsdl=1
995 INCSDL="$PATH_SDK_LIBSDL/Headers"
996 FLDSDL="-framework SDL"
997 else
998 log_failure "SDL framework not found"
999 fail
1000 fi
1001 else
1002 if which_wrapper sdl-config > /dev/null; then
1003 FLGSDL=`sdl-config --cflags`
1004 INCSDL=`strip_I "$FLGSDL"`
1005 LIBSDL=`sdl-config --libs`
1006 LIBSDLMAIN="-lSDLmain"
1007 FLDSDL=
1008 foundsdl=1
1009 fi
1010 fi
1011 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1012 if [ -n "$foundsdl" ]; then
1013 cat > $ODIR.tmp_src.cc << EOF
1014#include <cstdio>
1015#include <SDL.h>
1016#include <SDL_main.h>
1017#undef main
1018extern "C" int main(int argc, char** argv)
1019{
1020 printf("found version %d.%d.%d",
1021 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1022#if SDL_VERSION_ATLEAST(1,2,7)
1023 printf(", OK.\n");
1024 return 0;
1025#else
1026 printf(", expected version 1.2.7 or higher\n");
1027 return 1;
1028#endif
1029}
1030EOF
1031 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1032 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1033 if test_execute; then
1034 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1035 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1036 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1037 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1038 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1039 fi
1040 fi
1041 else
1042 log_failure "not found"
1043 fail
1044 fi
1045}
1046
1047
1048#
1049# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1050#
1051check_sdl_ttf()
1052{
1053 test_header SDL_ttf
1054 cat > $ODIR.tmp_src.cc << EOF
1055#include <cstdio>
1056#include <SDL_ttf.h>
1057#ifndef SDL_TTF_MAJOR_VERSION
1058#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1059#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1060#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1061#endif
1062extern "C" int main(void)
1063{
1064 printf("found version %d.%d.%d",
1065 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1066#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1067 printf(", OK.\n");
1068 return 0;
1069#else
1070 printf(", expected version 2.0.6 or higher\n");
1071 return 1;
1072#endif
1073}
1074EOF
1075 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1076 if ! test_execute nofatal; then
1077 cnf_append "VBOX_WITH_SECURELABEL" ""
1078 fi
1079 else
1080 cnf_append "VBOX_WITH_SECURELABEL" ""
1081 fi
1082}
1083
1084
1085#
1086# Check for libasound, needed by the ALSA audio backend
1087#
1088check_alsa()
1089{
1090 test_header ALSA
1091 cat > $ODIR.tmp_src.cc << EOF
1092#include <cstdio>
1093#include <alsa/asoundlib.h>
1094extern "C" int main(void)
1095{
1096 printf("found version %d.%d.%d",
1097 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1098#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
1099 printf(", OK.\n");
1100 return 0;
1101#else
1102 printf(", expected version 1.0.6 or higher\n");
1103 return 1;
1104#endif
1105}
1106EOF
1107 if test_compile "-lasound" asound asound; then
1108 test_execute
1109 fi
1110}
1111
1112
1113#
1114# Check for PulseAudio
1115#
1116check_pulse()
1117{
1118 test_header "PulseAudio"
1119 cat > $ODIR.tmp_src.cc << EOF
1120#include <cstdio>
1121#include <pulse/version.h>
1122extern "C" int main(void)
1123{
1124 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1125#if PA_API_VERSION >= 9
1126 printf(", OK.\n");
1127 return 0;
1128#else
1129 printf(", expected version 0.9.0 (API version 9) or higher\n");
1130 return 1;
1131#endif
1132}
1133EOF
1134 if test_compile "-lpulse" pulse pulse; then
1135 test_execute
1136 fi
1137}
1138
1139
1140#
1141# Check for the X libraries (Xext, X11)
1142#
1143check_x()
1144{
1145 test_header "X libraries"
1146 cat > $ODIR.tmp_src.cc << EOF
1147#include <cstdio>
1148#include <X11/Xlib.h>
1149extern "C" int main(void)
1150{
1151 Display *dpy;
1152 int scrn_num;
1153 Screen *scrn;
1154 Window win;
1155
1156 dpy = XOpenDisplay(NULL);
1157 scrn_num = DefaultScreen(dpy);
1158 scrn = ScreenOfDisplay(dpy, scrn_num);
1159 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1160 0, 16, InputOutput, CopyFromParent, 0, NULL);
1161 XDestroyWindow(dpy, win);
1162}
1163EOF
1164 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1165 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1166 log_success "found"
1167 fi
1168}
1169
1170
1171#
1172# Check for the Xcursor library, needed by VBoxSDL and VBoxBFE
1173#
1174check_xcursor()
1175{
1176 test_header Xcursor
1177 cat > $ODIR.tmp_src.cc << EOF
1178#include <cstdio>
1179#include <X11/Xlib.h>
1180#include <X11/Xcursor/Xcursor.h>
1181extern "C" int main(void)
1182{
1183 XcursorImage *cursor = XcursorImageCreate (10, 10);
1184 XcursorImageDestroy(cursor);
1185 return 0;
1186}
1187EOF
1188 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1189 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1190 log_success "found"
1191 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1192 fi
1193}
1194
1195
1196#
1197# Check for the Xmu library, needed by OpenGL
1198#
1199check_xmu()
1200{
1201 test_header Xmu
1202 cat > $ODIR.tmp_src.cc << EOF
1203#include <cstdio>
1204#include <X11/Xatom.h>
1205#include <X11/Xlib.h>
1206#include <X11/Xutil.h>
1207#include <X11/Xmu/StdCmap.h>
1208extern "C" int main(void)
1209{
1210 Display *dpy;
1211 int scrn_num;
1212 Screen *scrn;
1213
1214 dpy = XOpenDisplay(NULL);
1215 if (dpy)
1216 {
1217 scrn_num = DefaultScreen(dpy);
1218 scrn = ScreenOfDisplay(dpy, scrn_num);
1219 Status status = XmuLookupStandardColormap(dpy, RootWindowOfScreen(scrn), 0,
1220 24, XA_RGB_DEFAULT_MAP, False, True);
1221 printf("Status = %x\n", status);
1222 }
1223 return 0;
1224}
1225EOF
1226 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1227 if test_compile "$LIBX11 $LIBXMU $I_INCX11" Xmu Xmu; then
1228 log_success "found"
1229 cnf_append "VBOX_XMU_LIBS" "`strip_l "$LIBXMU"`"
1230 fi
1231}
1232
1233
1234#
1235# Check for Mesa, needed by OpenGL
1236#
1237check_mesa()
1238{
1239 test_header "Mesa / GLU"
1240 cat > $ODIR.tmp_src.cc << EOF
1241#include <cstdio>
1242#include <X11/Xlib.h>
1243#include <GL/glx.h>
1244#include <GL/glu.h>
1245extern "C" int main(void)
1246{
1247 Display *dpy;
1248 int major, minor;
1249
1250 dpy = XOpenDisplay(NULL);
1251 if (dpy)
1252 {
1253 if (glXQueryVersion(dpy, &major, &minor))
1254 {
1255 printf("found version %u.%u, OK.\n", major, minor);
1256 return 0;
1257 }
1258 }
1259 printf("found (inactive), OK.\n");
1260 return 0;
1261}
1262EOF
1263 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1264 if test_compile "$LIBX11 $MESA $I_INCX11" Mesa Mesa; then
1265 test_execute
1266 fi
1267}
1268
1269
1270#
1271# Check for the Qt4 library, needed by the VirtualBox frontend
1272#
1273# Currently not fatal.
1274#
1275check_qt4()
1276{
1277 foundqt4=
1278 test_header Qt4
1279 if [ "$OS" = "darwin" ]; then
1280 if [ -f "/System/Library/Frameworks/QtCore.framework/QtCore" ]; then
1281 PATH_SDK_QT4="/System/Library/Framework/QtCore.framework"
1282 elif [ -f "/Library/Frameworks/QtCore.framework/QtCore" ]; then
1283 PATH_SDK_QT4="/Library/Frameworks/QtCore.framework"
1284 fi
1285 if [ -n "$PATH_SDK_QT4" ]; then
1286 foundqt4=1
1287 INCQT4="$PATH_SDK_QT4/Headers"
1288 LIBQT4=
1289 FLGQT4="-framework QtCore"
1290 else
1291 log_failure "Qt4 framework not found (can be disabled using --disable-qt4)"
1292 fail
1293 fi
1294 else
1295 if [ $QT4DIR_PKGCONFIG -eq 1 ]; then
1296 # default is to use pkg-config
1297 if which_wrapper pkg-config > /dev/null; then
1298 # this braindead path is necessary for mdv2008.1
1299 qt4_ver=`\
1300 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1301 pkg-config QtCore --modversion 2>> $LOG`
1302 if [ $? -ne 0 ]; then
1303 log_failure "not found"
1304 fail
1305 else
1306 FLGQT4=`\
1307 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1308 pkg-config QtCore --cflags`
1309 INCQT4=`strip_I "$FLGQT4"`
1310 LIBQT4=`\
1311 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1312 PKG_CONFIG_ALLOW_SYSTEM_LIBS=1 \
1313 pkg-config QtCore --libs`
1314 foundqt4=1
1315 fi
1316 else
1317 log_failure "pkg-config not found"
1318 fail
1319 fi
1320 else
1321 # do it the old way (e.g. user has specified QT4DIR)
1322 cat > $ODIR.tmp_src.cc << EOF
1323#include <cstdio>
1324#include <QtGlobal>
1325extern "C" int main(void)
1326{
1327 printf("found version %s", QT_VERSION_STR);
1328#if QT_VERSION >= 0x040300
1329 printf(", OK.\n");
1330 return 0;
1331#else
1332 printf(", expected version 4.3.0 or higher\n");
1333 return 1;
1334#endif
1335}
1336EOF
1337 for q in $QT4DIR; do
1338 INCQT4="$q/include $q/include/QtCore"
1339 FLGQT4="-DQT_SHARED"
1340 I_INCQT4=`prefix_I "$INCQT4"`
1341 LIBQT4="-L$q/lib -lQtCoreVBox"
1342 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1343 foundqt4=2
1344 break;
1345 fi
1346 LIBQT4="-L$q/lib -lQtCore"
1347 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1348 foundqt4=1
1349 break;
1350 fi
1351 done
1352 fi
1353 fi
1354 if [ -n "$foundqt4" ]; then
1355 cat > $ODIR.tmp_src.cc << EOF
1356#include <cstdio>
1357#include <QtGlobal>
1358extern "C" int main(void)
1359{
1360 printf("found version %s", QT_VERSION_STR);
1361#if QT_VERSION >= 0x040300
1362 printf(", OK.\n");
1363 return 0;
1364#else
1365 printf(", expected version 4.3.0 or higher\n");
1366 return 1;
1367#endif
1368}
1369EOF
1370 [ -n "$INCQT4" ] && I_INCQT4=`prefix_I "$INCQT4"`
1371 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1372 if test_execute_path "`strip_L "$LIBQT4"`"; then
1373 if [ "$OS" != "darwin" ]; then
1374 # strip .../QtCore as we add components ourself
1375 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1376 # store only the first path, remove all other pathes
1377 # most likely pkg-config gave us -I/usr/include/qt4 -I/usr/include/qt4/QtCore
1378 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1379 cnf_append "VBOX_PATH_QT4_LIB" "`strip_L "$LIBQT4"`"
1380 cnf_append "SDK_QT4_LIBPATH" "`strip_L "$LIBQT4"`"
1381 cnf_append "PATH_SDK_QT4_INC" "$INCQT4"
1382 # this is not quite right since the qt libpath does not have to be first...
1383 cnf_append "PATH_SDK_QT4_LIB" '$'"(firstword `strip_L "$LIBQT4"`)"
1384 if [ "$foundqt4" = "2" ]; then
1385 cnf_append "VBOX_WITH_QT4_SUN" "1"
1386 fi
1387 test_header "Qt4 devtools"
1388 for q in $QT4DIR; do
1389 if which_wrapper "$q/bin/moc" > /dev/null; then
1390 moc_ver=`$q/bin/moc -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1391 if [ $? -ne 0 ]; then
1392 log_failure "not found"
1393 fail
1394 else
1395 log_success "found version $moc_ver"
1396 cnf_append "VBOX_PATH_QT4" "$q"
1397 cnf_append "PATH_SDK_QT4" "$q"
1398 cnf_append "PATH_TOOL_QT4" "$q"
1399 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1400 return
1401 fi
1402 fi
1403 done
1404 fi
1405 fi
1406 else
1407 log_failure "not found"
1408 fail
1409 fi
1410 else
1411 log_failure "not found"
1412 fail
1413 fi
1414}
1415
1416
1417#
1418# Check whether static libstdc++ is installed. This library is required
1419# for the Linux guest additions.
1420#
1421check_staticlibstdcxx()
1422{
1423 test_header "static stc++ library"
1424 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1425 cat > $ODIR.tmp_src.cc << EOF
1426#include <string>
1427
1428extern "C" int main(void)
1429{
1430 std::string s = "test";
1431 return 0;
1432}
1433EOF
1434 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1435 log_success "found"
1436 fi
1437}
1438
1439
1440#
1441# Check for Linux sources
1442#
1443check_linux()
1444{
1445 test_header "Linux kernel sources"
1446 cat > $ODIR.tmp_src.c << EOF
1447#include <linux/version.h>
1448int printf(const char *format, ...);
1449int main(void)
1450{
1451 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1452 (LINUX_VERSION_CODE % 65536) / 256,
1453 LINUX_VERSION_CODE % 256);
1454#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1455 printf(", OK.\n");
1456 return 0;
1457#else
1458 printf(", expected version 2.4.0 or higher\n");
1459 return 1;
1460#endif
1461}
1462EOF
1463 echo "compiling the following source file:" >> $LOG
1464 cat $ODIR.tmp_src.c >> $LOG
1465 echo "using the following command line:" >> $LOG
1466 echo "$CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include" >> $LOG
1467 $CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include >> $LOG 2>&1
1468 if [ $? -ne 0 ]; then
1469 echo
1470 echo " Linux kernel headers not found at $LINUX"
1471 echo " Check the file $LOG for detailed error information."
1472 fail
1473 else
1474 if test_execute; then
1475 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1476 fi
1477 fi
1478}
1479
1480
1481#
1482# Check for kchmviewer, needed to display the online help
1483# (unused as we ship kchmviewer)
1484#
1485check_kchmviewer()
1486{
1487 test_header kchmviewer
1488 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1489 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1490 if [ $? -ne 0 ]; then
1491 log_failure "not found"
1492 fail
1493 else
1494 log_success "found version $kchmviewer_ver"
1495 fi
1496 fi
1497}
1498
1499
1500#
1501# Check for the kBuild tools, we don't support GNU make
1502#
1503check_kbuild()
1504{
1505 test_header kBuild
1506 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1507 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1508 echo "export PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1509 echo "export PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1510 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1511 echo "export PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1512 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1513 if [ "$OS" = "solaris" ]; then
1514 # Because of sh being non-default shell in Solaris we need to export PATH again when
1515 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1516 echo "PATH=\"$ORGPATH\"" >> $ENV
1517 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1518 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1519 else
1520 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1521 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1522 fi
1523 echo "export PATH" >> $ENV
1524 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1525 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1526 elif check_avail "kmk" KBUILDDIR really; then
1527 # check for installed kBuild
1528 KBUILD_SED="`which_wrapper kmk_sed`"
1529 else
1530 fail
1531 fi
1532 log_success "found"
1533}
1534
1535
1536#
1537# Check for compiler.h
1538# Some Linux distributions include "compiler.h" in their libc linux
1539# headers package, some don't. Most don't need it, building might (!)
1540# not succeed on openSUSE without it.
1541#
1542# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1543#
1544check_compiler_h()
1545{
1546 test_header compiler.h
1547 if ! test -f "/usr/include/linux/compiler.h"; then
1548 log_success "compiler.h not found"
1549 else
1550 cnf_append "VBOX_WITH_LINUX_COMPILER_H" "1"
1551 log_success "compiler.h found"
1552 fi
1553}
1554
1555#
1556# Check for libcap.
1557# Required to pass CAP_NET_RAW to our binaries to allow to open SOCK_RAW
1558# sockets for doing ICMP requests.
1559#
1560check_libcap()
1561{
1562 test_header "libcap library"
1563 cat > $ODIR.tmp_src.cc << EOF
1564#include <cstdio>
1565#include <sys/capability.h>
1566
1567extern "C" int main(void)
1568{
1569 char buf[1024];
1570 cap_t caps = cap_get_proc();
1571 snprintf(buf, sizeof(buf), "Current caps are '%s'\n", cap_to_text(caps, NULL));
1572 return 0;
1573}
1574EOF
1575 if test_compile $LIBCAP libcap libcap; then
1576 if test_execute; then
1577 log_success "found"
1578 fi
1579 fi
1580}
1581
1582#
1583# Check if we are able to build 32-bit applications (needed for the guest additions)
1584#
1585check_32bit()
1586{
1587 test_header "32-bit support"
1588 cat > $ODIR.tmp_src.c << EOF
1589#include <stdint.h>
1590int main(void)
1591{
1592 return 0;
1593}
1594EOF
1595 echo "compiling the following source file:" >> $LOG
1596 cat $ODIR.tmp_src.c >> $LOG
1597 echo "using the following command line:" >> $LOG
1598 echo "$CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
1599 $CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
1600 if [ $? -ne 0 ]; then
1601 echo
1602 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1603 echo " Check the file $LOG for detailed error information."
1604 fail
1605 fi
1606 log_success ""
1607}
1608
1609
1610#
1611# Check for Python
1612#
1613check_python()
1614{
1615 test_header "python support"
1616 cat > $ODIR.tmp_src.cc << EOF
1617#include <cstdio>
1618#include <Python.h>
1619extern "C" int main(void)
1620{
1621 Py_Initialize();
1622 printf("found version %s", PY_VERSION);
1623#if PY_VERSION_HEX >= 0x02030000
1624 printf(", OK.\n");
1625 return 0;
1626#else
1627 printf(", expected version 2.3 or higher\n");
1628 return 1;
1629#endif
1630}
1631EOF
1632 found=
1633# For Solaris we use libpython2.4 for compatibility with Solaris 10 and passing IPS pkg audit
1634 if [ "$OS" != "solaris" ]; then
1635 SUPPYTHONLIBS="python2.6 python2.5 python2.4 python2.3"
1636 else
1637 SUPPYTHONLIBS="python2.4"
1638 fi
1639 for p in $PYTHONDIR; do
1640 for d in $SUPPYTHONLIBS; do
1641 for b in lib64 lib/64 lib; do
1642 echo "compiling the following source file:" >> $LOG
1643 cat $ODIR.tmp_src.cc >> $LOG
1644 echo "using the following command line:" >> $LOG
1645 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so" >> $LOG
1646 $CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so >> $LOG 2>&1
1647 if [ $? -eq 0 ]; then
1648 found=1
1649 break
1650 fi
1651 done
1652 if [ -n "$found" ]; then break; fi
1653 done
1654 if [ -n "$found" ]; then break; fi
1655 done
1656 if [ -n "$found" ]; then
1657 if test_execute; then
1658 cnf_append "VBOX_WITH_PYTHON" "1"
1659 cnf_append "VBOX_PATH_PYTHON_INC" "$p/include/$d"
1660 cnf_append "VBOX_LIB_PYTHON" "$p/$b/lib$d.so"
1661 else
1662 log_failure "not found"
1663 fail
1664 fi
1665 else
1666 log_failure "not found"
1667 fail
1668 fi
1669}
1670
1671
1672#
1673# Setup wine
1674#
1675setup_wine()
1676{
1677 test_header "Wine support"
1678 if ! which_wrapper wine > /dev/null; then
1679 echo " wine binary not found"
1680 fail
1681 fi
1682 if ! which_wrapper wineprefixcreate > /dev/null; then
1683 echo " wineprefixcreate not found"
1684 fail
1685 fi
1686 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
1687 echo "export WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
1688 rm -rf $WINEPREFIX
1689 mkdir -p $WINEPREFIX
1690 touch $WINEPREFIX/.no_prelaunch_window_flag
1691 if ! wineprefixcreate -q > /dev/null 2>&1; then
1692 echo " wineprefixcreate failed"
1693 fail
1694 fi
1695 tmp=.tmp.wine.reg
1696 rm -f $tmp
1697 echo 'REGEDIT4' > $tmp
1698 echo '' >> $tmp
1699 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
1700 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
1701 echo '' >> $tmp
1702 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
1703 echo '"itss"="native"' >> $tmp
1704 echo '' >> $tmp
1705 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
1706 echo '"itss"="native"' >> $tmp
1707 echo '' >> $tmp
1708 if ! wine regedit $tmp > /dev/null 2>&1; then
1709 rm -f $tmp
1710 echo " failed to load registry changes (path)."
1711 fail
1712 fi
1713 rm -f $tmp
1714 log_success "found"
1715}
1716
1717#
1718# Check for gSOAP.
1719#
1720check_gsoap()
1721{
1722 test_header "GSOAP compiler"
1723 if [ -z "$GSOAP" ]; then
1724 GSOAP="/usr"
1725 fi
1726 if which_wrapper "$GSOAP/bin/soapcpp2" > /dev/null; then
1727 if which_wrapper "$GSOAP/bin/wsdl2h" > /dev/null; then
1728 if [ -f "$GSOAP/include/stdsoap2.h" ]; then
1729 # TODO: Check for libgsoap++.a/so
1730
1731 if [ -z "$GSOAP_IMPORT" ]; then
1732 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
1733 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
1734 GSOAP_IMPORT="$GSOAP/include/gsoap"
1735 fi
1736 fi
1737 if [ -f "$GSOAP_IMPORT/stlvector.h" ]; then
1738 cnf_append "VBOX_GSOAP_INSTALLED" "1"
1739 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
1740 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
1741 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
1742 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
1743 else
1744 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
1745 fi
1746 cnf_append "VBOX_GSOAP_CXX_LIBS" "libgsoap++"
1747 log_success "found"
1748 else
1749 log_failure "stlvector.h not found -- disabling webservice"
1750 cnf_append "VBOX_WITH_WEBSERVICES" ""
1751 fi
1752 else
1753 log_failure "stdsoap2.h not found -- disabling webservice"
1754 cnf_append "VBOX_WITH_WEBSERVICES" ""
1755 fi
1756 else
1757 log_failure "wsdl2h not found -- disabling webservice"
1758 cnf_append "VBOX_WITH_WEBSERVICES" ""
1759 fi
1760 else
1761 log_failure "soapcpp2 not found -- disabling webservice"
1762 cnf_append "VBOX_WITH_WEBSERVICES" ""
1763 fi
1764}
1765
1766
1767#
1768# Determines the Darwin version.
1769# @todo This should really check the Xcode/SDK version.
1770#
1771check_darwinversion()
1772{
1773 test_header "Darwin version"
1774 darwin_ver=`uname -r`
1775 case "$darwin_ver" in
1776 9\.*)
1777 darwin_ver="10.5"
1778 #cnf_append "VBOX_TARGET_MAC_OS_X_VERSION_10_5" "1"
1779 ;;
1780 8\.*)
1781 darwin_ver="10.4"
1782 ;;
1783 *)
1784 echo " failed to determin darwin version. (uname -r: $darwin_ver)"
1785 fail
1786 darwin_ver="unknown"
1787 ;;
1788 esac
1789 log_success "found version $darwin_ver"
1790}
1791
1792
1793#
1794# Checks that i386-elf-gcc-3.4.6, i386-elf-gcc-3.4.3, i386-elf-gcc-3.4 or i386-elf-gcc
1795# is around to prevent confusion when the build fails in src/recompiler.
1796# Note. Keep the which order in sync with the $(which ) in src/recompiler/Makefile.kmk.
1797#
1798check_i386elfgcc()
1799{
1800 test_header "i386-elf-gcc"
1801 i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.6`
1802 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.3`
1803 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4`
1804 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc`
1805 if test -z "$i386_elf_gcc"; then
1806 echo " failed to find i386-elf-gcc"
1807 fail
1808 fi
1809 log_success "found $i386_elf_gcc"
1810}
1811
1812
1813#
1814# Show help
1815#
1816show_help()
1817{
1818 cat << EOF
1819Usage: ./configure [OPTIONS]...
1820
1821Configuration:
1822 -h, --help display this help and exit
1823 --nofatal don't abort on errors
1824 --disable-xpcom disable XPCOM and related stuff
1825 --disable-python disable python bindings
1826 --disable-sdl-ttf disable SDL_ttf detection
1827 --disable-alsa disable the ALSA sound backend
1828 --disable-pulse disable the PulseAudio backend
1829 --disable-dbus don't use DBus and hal for hardware detection
1830 --disable-kmods don't build Linux kernel modules (host and guest)
1831 --disable-hardening don't be strict about /dev/vboxdrv access
1832 --disable-opengl disable OpenGL support
1833 --enable-webservice enable the webservice stuff
1834 --build-libxml2 build libxml2 from sources
1835 --build-libxslt build libxslt from sources
1836 --setup-wine setup a Wine directory and register the hhc hack
1837
1838Paths:
1839 --with-gcc=PATH location of the gcc compiler [$CC]
1840 --with-g++=PATH location of the g++ compiler [$CXX]
1841 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
1842 --with-iasl=PATH location of the iasl compiler [$IASL]
1843 --with-linux=DIR Linux kernel source directory [$LINUX]
1844 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
1845 --with-qt-dir=DIR directory for Qt4 headers/libraries [pkgconfig]
1846 --with-gsoap-dir=PATH directory for gSOAP compiler/headers/libraries
1847 (soapcpp2 and wsdl2h, soapstd2.h, libgsoap++.a/so)
1848 --with-gsoap-import=PATH directory for gSOAP import files (stlvector.h)
1849 --out-path=PATH the folder to which configuration and build output
1850 should go
1851
1852Build type:
1853 -d, --build-debug build with debugging symbols and assertions
1854 --build-profile build with profiling support
1855 --build-headless build headless (without any X11 frontend)
1856EOF
1857 exit 0
1858}
1859
1860
1861#
1862# The body.
1863#
1864
1865# scan command line options
1866for option in $*; do
1867 case "$option" in
1868 --help|-help|-h)
1869 show_help
1870 ;;
1871 --nofatal)
1872 nofatal=1
1873 ;;
1874 --env-only)
1875 ENV_ONLY=1
1876 ;;
1877 --with-gcc=*)
1878 CC=`echo $option | cut -d'=' -f2`
1879 ;;
1880 --with-g++=*)
1881 CXX=`echo $option | cut -d'=' -f2`
1882 ;;
1883 --with-kbuild=*)
1884 KBUILDDIR=`echo $option | cut -d'=' -f2`
1885 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
1886 echo "Error: KBUILDDIR contains invalid characters!"
1887 exit 1
1888 fi
1889 ;;
1890 --with-qt-dir=*|--with-qt4-dir=*)
1891 QT4DIR=`echo $option | cut -d'=' -f2`
1892 QT4DIR_PKGCONFIG=0
1893 ;;
1894 --with-gsoap-dir=*)
1895 GSOAP=`echo $option | cut -d'=' -f2`
1896 ;;
1897 --with-gsoap-import=*)
1898 GSOAP_IMPORT=`echo $option | cut -d'=' -f2`
1899 ;;
1900 --with-iasl=*)
1901 IASL=`echo $option | cut -d'=' -f2`
1902 ;;
1903 --with-linux=*)
1904 LINUX=`echo $option | cut -d'=' -f2`
1905 ;;
1906 --with-mkisofs=*)
1907 MKISOFS=`echo $option | cut -d'=' -f2`
1908 ;;
1909 --disable-xpcom)
1910 WITH_XPCOM=0
1911 ;;
1912 --disable-python)
1913 WITH_PYTHON=0
1914 ;;
1915 --disable-sdl-ttf)
1916 WITH_SDL_TTF=0
1917 ;;
1918 --disable-qt)
1919 WITH_QT4=0
1920 ;;
1921 --disable-qt4)
1922 WITH_QT4=0
1923 ;;
1924 --disable-alsa)
1925 WITH_ALSA=0
1926 ;;
1927 --disable-pulse)
1928 WITH_PULSE=0
1929 ;;
1930 --disable-dbus)
1931 WITH_DBUS=0
1932 ;;
1933 --disable-kmods)
1934 WITH_KMODS=0
1935 ;;
1936 --disable-opengl)
1937 WITH_OPENGL=0
1938 ;;
1939 --disable-hardening)
1940 WITH_HARDENING=0
1941 ;;
1942 --enable-hardening)
1943 WITH_HARDENING=2
1944 ;;
1945 --enable-webservice)
1946 WITH_GSOAP=1
1947 ;;
1948 --build-debug|-d)
1949 BUILD_TYPE=debug
1950 ;;
1951 --build-profile)
1952 BUILD_TYPE=profile
1953 ;;
1954 --build-libxml2)
1955 BUILD_LIBXML2=1
1956 ;;
1957 --build-libxslt)
1958 BUILD_LIBXSLT=1
1959 ;;
1960 --build-headless)
1961 HEADLESS=1
1962 WITH_SDL=0
1963 WITH_SDL_TTF=0
1964 WITH_X11=0
1965 WITH_OPENGL=0
1966 WITH_QT4=0
1967 ;;
1968 --ose)
1969 OSE=2
1970 ;;
1971 --odir=*)
1972 ODIR="`echo $option | cut -d'=' -f2`/"
1973 ODIR_OVERRIDE=1
1974 ;;
1975 --out-path=*)
1976 out_path="`echo $option | cut -d'=' -f2`/"
1977 if [ -d $out_path ]; then
1978 saved_path="`pwd`"
1979 cd $out_path
1980 OUT_PATH="`pwd`"
1981 cd $saved_path
1982 OUT_PATH_OVERRIDE=1
1983 if [ $ODIR_OVERRIDE -eq 0 ]; then
1984 # This variable has not *yet* been overridden. That can still happen.
1985 ODIR=$OUT_PATH/
1986 fi
1987 else
1988 echo "Error: invalid folder \"$out_path\" in option \"$option\""
1989 exit 1
1990 fi
1991 ;;
1992 --setup-wine)
1993 SETUP_WINE=1
1994 ;;
1995 *)
1996 echo
1997 echo "Unrecognized option \"$option\""
1998 echo
1999 show_help
2000 ;;
2001 esac
2002done
2003
2004LOG="$ODIR$LOG"
2005ENV="$ODIR$ENV"
2006CNF="$ODIR$CNF"
2007
2008# initialize output files
2009cat > $LOG << EOF
2010# Log file generated by
2011#
2012# '$0 $*'
2013#
2014
2015EOF
2016cat > $CNF << EOF
2017# -*- Makefile -*-
2018#
2019# automatically generated by
2020#
2021# '$0 $*'
2022#
2023# It will be completely overwritten if configure is executed again.
2024#
2025
2026EOF
2027cat > $ENV << EOF
2028#!/bin/bash
2029#
2030# automatically generated by
2031#
2032# '$0 $*'
2033#
2034# It will be completely overwritten if configure is executed again.
2035# Make sure you source this file once before you start to build VBox.
2036#
2037
2038EOF
2039
2040# test if we are OSE
2041if [ $OSE -eq 1 -a -d "`cd \`dirname $0\`; pwd`/src/VBox/Devices/USB" ]; then
2042 echo "Found USB devices, assuming VBOX_OSE = FALSE" >> $LOG
2043 echo >> $LOG
2044 OSE=0
2045fi
2046
2047if [ "$BUILD_TYPE" = "debug" ]; then
2048 echo "Creating DEBUG build!" >> $LOG
2049elif [ "$BUILD_TYPE" = "profile" ]; then
2050 echo "Creating PROFILE build!" >> $LOG
2051fi
2052
2053# first determine our environment
2054check_environment
2055check_kbuild
2056
2057[ -n "$ENV_ONLY" ] && exit 0
2058
2059# append the tools directory to the default search path
2060echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
2061export PATH
2062
2063# if we will be writing to a different out directory then set this up now
2064if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2065 echo "export AUTOCFG=$OUT_PATH/AutoConfig.kmk" >> $ENV
2066 echo "export LOCALCFG=$OUT_PATH/LocalConfig.kmk" >> $ENV
2067 echo "export PATH_OUT_BASE=$OUT_PATH" >> $ENV
2068fi
2069
2070# some things are not available in for OSE
2071if [ $OSE -ge 1 ]; then
2072 cnf_append "VBOX_OSE" "1"
2073 cnf_append "VBOX_WITH_TESTSUITE" ""
2074 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
2075
2076 if [ "$OS" = "linux" ]; then
2077 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
2078 else
2079 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
2080 fi
2081 echo >> $CNF
2082fi
2083
2084# headless
2085if [ -n "$HEADLESS" ]; then
2086 cnf_append "VBOX_HEADLESS" "1"
2087fi
2088
2089if [ $WITH_OPENGL -eq 0 ]; then
2090 cnf_append "VBOX_WITH_CROGL" ""
2091fi
2092
2093if [ "$OS" = "darwin" ]; then
2094 # On Darwin we want to build against Qt4 only. WITH_QT4 is enabled by
2095 # default so disable Qt3. --disable-qt disables both Qt3 and Qt4 GUI now,
2096 # --disable-qt4 disables only the Qt4 GUI (which is not appropriate for
2097 # Darwin as we disable the Qt3 here anyway.
2098 # (Qt3 builds for Intel Macs are usually not threaded or for X11. And they
2099 # don't contain our patches, which means the result isn't really usable.)
2100 BUILD_LIBXSLT=1
2101 BUILD_LIBXML2=1
2102fi
2103
2104# emit disable directives corresponding to any --disable-xxx options.
2105[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
2106[ $WITH_QT4 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
2107[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
2108[ $WITH_HARDENING -eq 0 ] && cnf_append "VBOX_WITHOUT_HARDENING" "1"
2109[ $WITH_HARDENING -eq 2 ] && cnf_append "VBOX_WITH_HARDENING" "2"
2110
2111# the tools
2112check_gcc
2113[ "$OS" != "darwin" ] && check_as86
2114[ "$OS" != "darwin" ] && check_bcc
2115[ "$OS" != "darwin" ] && check_iasl
2116# don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
2117# [ "$OS" != "darwin" ] && check_yasm
2118[ "$OS" != "darwin" ] && check_xsltproc
2119[ $OSE -eq 0 -a "$OS" != "darwin" ] && check_mkisofs
2120
2121# the libraries
2122[ "$OS" != "darwin" ] && check_pthread
2123[ $WITH_XPCOM -eq 1 ] && check_libxml2
2124[ $WITH_XPCOM -eq 1 ] && check_libxslt
2125[ $WITH_LIBIDL -eq 1 ] && check_libidl
2126# build openssl on Darwin in every case
2127[ "$OS" != "darwin" -a $OSE -eq 0 ] && check_ssl
2128[ "$OS" != "darwin" ] && check_z
2129[ "$OS" != "darwin" -a "$OS" != "freebsd" ] && check_png
2130[ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
2131[ $WITH_SDL -eq 1 ] && check_sdl
2132[ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
2133[ $WITH_X11 -eq 1 ] && check_x
2134# TODO check for xcomposite-dev (X11/extensions/Xcomposite.h, additions only)
2135# TODO check for libxdamange-dev (X11/extensions/Xdamage.h, additions only)
2136[ $WITH_X11 -eq 1 ] && check_xcursor
2137[ $WITH_OPENGL -eq 1 ] && check_xmu
2138[ $WITH_OPENGL -eq 1 ] && check_mesa
2139[ $WITH_QT4 -eq 1 ] && check_qt4
2140[ $WITH_PYTHON -eq 1 -a "$OS" != "darwin" ] && check_python
2141
2142# Linux-specific
2143if [ "$OS" = "linux" ]; then
2144 # don't check for the static libstdc++ in the PUEL version as we build the
2145 # additions at a dedicated box
2146 [ $OSE -ge 1 ] && check_staticlibstdcxx
2147 if [ $WITH_KMODS -eq 1 ]; then
2148 check_linux
2149 else
2150 cnf_append "VBOX_LINUX_SRC" ""
2151 cnf_append "VBOX_WITH_VBOXDRV" ""
2152 cnf_append "VBOX_WITH_ADDITION_DRIVERS" ""
2153 fi
2154 if [ $WITH_ALSA -eq 1 ]; then
2155 check_alsa
2156 else
2157 cnf_append "VBOX_WITH_ALSA" ""
2158 fi
2159 if [ $WITH_PULSE -eq 1 ]; then
2160 check_pulse
2161 else
2162 cnf_append "VBOX_WITH_PULSE" ""
2163 fi
2164 if [ $WITH_DBUS -eq 0 ]; then
2165 cnf_append "VBOX_WITH_DBUS" ""
2166 fi
2167 check_libcap
2168 check_compiler_h
2169 [ "$BUILD_MACHINE" = "amd64" ] && check_32bit
2170fi
2171
2172[ -n "$SETUP_WINE" ] && setup_wine
2173
2174if [ $OSE -ge 1 ]; then
2175 if [ $WITH_GSOAP -eq 1 ]; then
2176 check_gsoap
2177 else
2178 cnf_append "VBOX_WITH_WEBSERVICES" ""
2179 fi
2180fi
2181
2182# Darwin-specific
2183if [ "$OS" = "darwin" ]; then
2184 check_darwinversion
2185 check_i386elfgcc
2186fi
2187
2188# success!
2189echo
2190echo "Successfully generated '$CNF' and '$ENV'."
2191echo "Source '$ENV' once before you start to build VBox:"
2192echo ""
2193echo " source $ENV"
2194echo " kmk"
2195echo ""
2196if [ "$OS" = "linux" ]; then
2197 if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2198 vbox_out_path=$OUT_PATH
2199 else
2200 vbox_out_path=./out
2201 fi
2202 echo "To compile the kernel module, do:"
2203 echo ""
2204 echo " cd $vbox_out_path/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src/vboxdrv"
2205 echo " make"
2206 echo ""
2207fi
2208if [ $WITH_HARDENING -gt 0 ]; then
2209 echo ""
2210 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2211 echo " Hardening is enabled which means that the VBox binaries will not run from"
2212 echo " the binary directory. The binaries have to be installed suid root and some"
2213 echo " more prerequisites have to be fulfilled which is normally done by installing"
2214 echo " the final package. For development, the hardening feature can be disabled"
2215 echo " by specifying the --disable-hardening parameter. Please never disable that"
2216 echo " feature for the final distribution!"
2217 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2218 echo ""
2219else
2220 echo ""
2221 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2222 echo " Hardening is disabled. Please do NOT build packages for distribution with"
2223 echo " disabled hardening!"
2224 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2225 echo ""
2226fi
2227echo "Enjoy!"
2228cleanup
Note: See TracBrowser for help on using the repository browser.

© 2024 Oracle Support Privacy / Do Not Sell My Info Terms of Use Trademark Policy Automated Access Etiquette